#include "game.h"
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define MAX_RAND_TRIES_PER_WORD 10
#define EMPTY_CHAR 0

//TODO: Spiellogik implementieren:
/* * Wörter aus der Wortliste zufällig horizontal oder vertikal platzieren
   * restliche Felder mit zufälligen Buchstaben füllen */

// Creates the word salad by placing words randomly and filling empty spaces
int createWordSalad(char salad[MAX_SEARCH_FIELD_LEN][MAX_SEARCH_FIELD_LEN], unsigned int searchFieldLen, const char words[][MAX_WORD_LEN], unsigned int wordCount)
{
   int r, c;

   //Gesamtes Feld auf 0 setzen
   for (r=0; r < searchFieldLen; r++) { 
      for (c=0; c < searchFieldLen; c++) {
         salad [r][c] = EMPTY_CHAR;
      }
   }
   
   //Wörter zufällig horizontal oder vertikal platzieren
   enum Richtung {HORIZONTAL,VERTIKAL}; //0;1
   enum Richtung dir;
   dir = (rand() % 2 == 0) ? HORIZONTAL : VERTIKAL;
      //Schleife, die das Setzen für alle Wörter durchführt, Zufällig horizontal(0) oder vertikal(1), an zufällige Stelle
      //Prüfen, ob das Wort von der Länge her ins Feld passt


   //Felder, in denen keine Wörter stehen, werden mit zufälligen Buchstaben befüllt
   for (r=0; r < searchFieldLen; r++) {
      for (c=0; c < searchFieldLen; c++) {
         if (salad[r][c] == EMPTY_CHAR) {
           salad [r][c] = 'A' + (rand()% 26); 
         }
      }
   }

   return 0;
}

// Prints the word salad to console
void showWordSalad(const char salad[MAX_SEARCH_FIELD_LEN][MAX_SEARCH_FIELD_LEN], unsigned int searchFieldLen)
{
   int r, c;

   //Ausgabe des gesamten Feldes
   for (r=0; r < searchFieldLen; r++) {
      for (c=0; c < searchFieldLen; c++) {
         printf("%c ", salad[r][c]);
      }
      printf("\n");
   }
}
